000000*-----------------------------------------------------------------
000010* SEARCH文(書き方1)を利用して、表から特定の要素を取り出します。
000020*-----------------------------------------------------------------
000030 IDENTIFICATION DIVISION.
000040 PROGRAM-ID. SEARCH01.
000050 DATA DIVISION.
000060 WORKING-STORAGE SECTION.
000070 01 GET-GOODS           PIC X(10).
000080 01 GET-NUM             PIC 9(4).
000090 01 TOTAL               PIC 9(4) value 0.
000100 01 COUNTER             PIC 9(1).
000110 01 PRICE-ED            PIC \\\\9.
000120 01 TOTAL-ED            PIC ZZZZ9.
000130 01 GOODS-DATA.
000140    02                  PIC X(10) VALUE "NOTEBOOK".
000150    02                  PIC 9(4)  VALUE 150.
000160    02                  PIC X(10) VALUE "PENCIL".
000170    02                  PIC 9(4)  VALUE 30.
000180    02                  PIC X(10) VALUE "ERASER".
000190    02                  PIC 9(4)  VALUE 50.
000200    02                  PIC X(10) VALUE "RULER".
000210    02                  PIC 9(4)  VALUE 100.
000220    02                  PIC X(10) VALUE "CUTTER".
000230    02                  PIC 9(4)  VALUE 200.
000240 01 DUMMY-COUNT         PIC 9(5)  VALUE 10.
000250*-----------------------------------------------------------------
000260* SEARCH文で利用する表には、指標名を指定しておきます。
000270*-----------------------------------------------------------------
000280 01 REDEFINES GOODS-DATA.
000290    02 GOODS OCCURS 5 TIMES INDEXED BY IX IY IZ.
000300       03 NAME          PIC X(10).
000310       03 PRICE         PIC 9(4).
000320 01.
000330    02 NG-GOODS OCCURS 5 TIMES INDEXED BY JX JY JZ PIC X(3).
000340*-----------------------------------------------------------------
000350 PROCEDURE DIVISION.
000360     PERFORM TEST BEFORE
000370         VARYING COUNTER FROM 1 BY 1 UNTIL COUNTER > 5
000380        MOVE PRICE(COUNTER) TO PRICE-ED
000390        DISPLAY COUNTER "." NAME(COUNTER) PRICE-ED
000400     END-PERFORM.
000410*------------------------------------------------------------
000420* SEARCH文には、検索該当時に実行する処理を記述します。
000430* 検索処理は指標により逐次実行されるため、指標に値を設定して検索
000440* 開始位置を指示します。また、検索処理は検索対象が見つかった時点
000450* で終了し、指標にはその時点の値が設定されています。このため、続
000460* けてSEARCH文を記述すると、続きから検索できます。
000470*-----------------------------------------------------------------
000480     MOVE "ERASER" TO GET-GOODS.
000490     MOVE 3 TO GET-NUM.
000500     SET IX TO 1.
000510     SEARCH GOODS
000520        WHEN NAME(IX) = GET-GOODS
000530           MOVE PRICE(IX) TO TOTAL
000540     END-SEARCH.
000550*-----------------------------------------------------------------
000560     DISPLAY " ".
000570     PERFORM DISP.
000000     IF IX = 3
000000        DISPLAY "OK" ELSE DISPLAY "NG".
000580*-----------------------------------------------------------------
000590     MOVE "RULER" TO GET-GOODS.
000600     MOVE 2 TO GET-NUM.
000610     SET IX TO 1.
000620     SET IY TO 1.
000630     SEARCH GOODS VARYING IY
000640        WHEN NAME(IY) = GET-GOODS
000650           MOVE PRICE(IY) TO TOTAL
000660     END-SEARCH.
000670*-----------------------------------------------------------------
000680     PERFORM DISP.
000000     IF IX = 1 AND IY = 4
000000        DISPLAY "OK" ELSE DISPLAY "NG".
000700*-----------------------------------------------------------------
000710     MOVE "PENCIL" TO GET-GOODS.
000720     MOVE 5 TO GET-NUM.
000730     SET IX TO 1.
000740     SET JX TO 2.
000750     SEARCH GOODS VARYING JX
000760        WHEN NAME(IX) = GET-GOODS
000770           MOVE PRICE(IX) TO TOTAL
000780     END-SEARCH.
000790*-----------------------------------------------------------------
000800     PERFORM DISP.
000000     IF IX = 2 AND JX = 3
000000        DISPLAY "OK" ELSE DISPLAY "NG".
000820*-----------------------------------------------------------------
000830     MOVE "CUTTER" TO GET-GOODS.
000840     MOVE 5 TO GET-NUM.
000850     SET IX TO 1.
000860     SEARCH GOODS VARYING DUMMY-COUNT
000870        WHEN NAME(IX) = GET-GOODS
000880           MOVE PRICE(IX) TO TOTAL
000890     END-SEARCH.
000900*-----------------------------------------------------------------
000910     PERFORM DISP.
000000     IF IX = 5 AND DUMMY-COUNT = 14
000000        DISPLAY "OK" ELSE DISPLAY "NG".
000920*-----------------------------------------------------------------
000930     MOVE "XXXXX" TO GET-GOODS.
000940     MOVE 5 TO GET-NUM.
000950     MOVE 0 TO TOTAL.
000960     SET IX TO 1.
000970     SEARCH GOODS
000980       AT END
000990           CONTINUE
001000       WHEN NAME(IX) = GET-GOODS
001010           MOVE PRICE(IX) TO TOTAL
001020       WHEN NAME(IX) = "YYY"
001030           DISPLAY "絶対に表示されない"
001040     END-SEARCH.
000900*-----------------------------------------------------------------
001050     PERFORM DISP.
000000     IF IX = 6
000000        DISPLAY "OK" ELSE DISPLAY "NG".
001070     STOP RUN.
001080*-----------------------------------------------------------------
001090 DISP.
001100     DISPLAY FUNCTION TRIM(GET-GOODS) " を " GET-NUM "個".
001110     IF TOTAL NOT = ZERO THEN
001120        COMPUTE TOTAL = TOTAL * GET-NUM
001130        MOVE TOTAL TO TOTAL-ED
001140        DISPLAY "  合計金額は、" TOTAL-ED "円です。"
001150     ELSE
001160        DISPLAY "  入力データに誤りがあります。"
001170     END-IF.
001180